osmo_ss7_vty.c File Reference
`#include <stdlib.h>`
`#include <unistd.h>`
`#include <errno.h>`
`#include <stdint.h>`
`#include <string.h>`
`#include <arpa/inet.h>`
`#include <osmocom/vty/vty.h>`
`#include <osmocom/vty/command.h>`
`#include <osmocom/vty/logging.h>`
`#include <osmocom/vty/telnet_interface.h>`
`#include <osmocom/vty/misc.h>`
`#include <osmocom/sigtran/osmo_ss7.h>`
`#include <osmocom/sigtran/protocol/mtp.h>`
`#include "xua_internal.h"`
`#include <osmocom/sigtran/sccp_sap.h>`
`#include "sccp_internal.h"`

## Data Structures

struct | osmo_sccp_addr_entry

## Macros

#define | XUA_VAR_STR "(sua|m3ua|ipa)"
#define | XUA_VAR_HELP_STR
#define | ROUTING_KEY_CMD "routing-key RCONTEXT DPC"
#define | ROUTING_KEY_CMD_STRS
#define | ROUTING_KEY_SI_ARG " si (aal2|bicc|b-isup|h248|isup|sat-isup|sccp|tup)"
#define | ROUTING_KEY_SI_ARG_STRS
#define | ROUTING_KEY_SSN_ARG " ssn SSN"
#define | ROUTING_KEY_SSN_ARG_STRS

## Enumerations

enum | cs7_role_t { CS7_ROLE_SG , CS7_ROLE_ASP }

## Functions

| DEFUN (cs7_instance, cs7_instance_cmd, "cs7 instance <0-15>", CS7_STR "Configure a SS7 Instance\n" INST_STR "Number of the instance\n")
| DEFUN (cs7_net_ind, cs7_net_ind_cmd, "network-indicator (international | national | reserved | spare)", "Configure the Network Indicator\n" "International Network\n" "National Network\n" "Reserved Network\n" "Spare Network\n")
| DEFUN (cs7_pc_format, cs7_pc_format_cmd, "point-code format <1-24> [<1-23>] [<1-22>]", PC_STR "Configure Point Code Format\n" "Length of first PC component\n" "Length of second PC component\n" "Length of third PC component\n")
| DEFUN (cs7_pc_format_def, cs7_pc_format_def_cmd, "point-code format default", PC_STR "Configure Point Code Format\n" "Default Point Code Format (3.8.3)\n")
| DEFUN (cs7_pc_delimiter, cs7_pc_delimiter_cmd, "point-code delimiter (default|dash)", PC_STR "Configure Point Code Delimiter\n" "Use dot as delimiter\n" "User dash as delimiter\n")
| DEFUN (cs7_point_code, cs7_point_code_cmd, "point-code POINT_CODE", "Configure the local Point Code\n" "Point Code\n")
| DEFUN (cs7_permit_dyn_rkm, cs7_permit_dyn_rkm_cmd, "xua rkm routing-key-allocation (static-only|dynamic-permitted)", "SIGTRAN xxxUA related\n" "Routing Key Management\n" "Routing Key Management Allocation Policy\n" "Only static (pre-confgured) Routing Keys permitted\n" "Dynamically allocate Routing Keys for what ASPs request\n")
static void | write_one_cs7 (struct vty *vty, struct osmo_ss7_instance *inst, bool show_dyn_config)
static int | write_all_cs7 (struct vty *vty, bool show_dyn_config)
static int | config_write_cs7 (struct vty *vty)
| DEFUN (show_cs7_user, show_cs7_user_cmd, "show cs7 instance <0-15> users", SHOW_STR CS7_STR INST_STR INST_STR "User Table\n")
| DEFUN (cs7_route_table, cs7_route_table_cmd, "route-table system", "Specify the name of the route table\n" "Name of the route table\n")
| DEFUN (cs7_rt_upd, cs7_rt_upd_cmd, "update route POINT_CODE MASK linkset LS_NAME [priority PRIO] [qos-class (CLASS|default)]", "Update the Route\n" "Update the Route\n" "Destination Point Code\n" "Point Code Mask\n" "Point Code Length\n" "Specify Destination Linkset\n" "Linkset Name\n" "Specify Priority\n" "Priority\n" "Specify QoS Class\n" "QoS Class\n" "Default QoS Class\n")
| DEFUN (cs7_rt_rem, cs7_rt_rem_cmd, "remove route POINT_CODE MASK", "Remove a Route\n" "Remove a Route\n" "Destination Point Code\n" "Point Code Mask\n" "Point Code Length\n")
static void | write_one_rtable (struct vty *vty, struct osmo_ss7_route_table *rtable)
static void | vty_dump_rtable (struct vty *vty, struct osmo_ss7_route_table *rtbl)
| DEFUN (show_cs7_route, show_cs7_route_cmd, "show cs7 instance <0-15> route", SHOW_STR CS7_STR INST_STR INST_STR "Routing Table\n")
static enum osmo_ss7_asp_protocol | parse_asp_proto (const char *protocol)
| DEFUN (cs7_xua, cs7_xua_cmd, "listen " XUA_VAR_STR " <0-65534>", "Configure/Enable xUA Listener\n" XUA_VAR_HELP_STR "SCTP Port number\n")
| DEFUN (no_cs7_xua, no_cs7_xua_cmd, "no listen " XUA_VAR_STR " <0-65534>", NO_STR "Disable xUA Listener on given SCTP Port\n" XUA_VAR_HELP_STR "SCTP Port number\n")
| DEFUN (xua_local_ip, xua_local_ip_cmd, "local-ip A.B.C.D", "Configure the Local IP Address for xUA\n" "IP Address to use for XUA\n")
| DEFUN (xua_accept_dyn_asp, xua_accept_dyn_asp_cmd, "accept-asp-connections (pre-configured|dynamic-permitted)", "Define what kind of ASP connections to accept\n" "Accept only pre-confiugred ASPs (source IP/prt)\n" "Accept any connection and dynamically create an ASP definition\n")
static void | write_one_xua (struct vty *vty, struct osmo_xua_server *xs)
static void | vty_dump_xua_server (struct vty *vty, struct osmo_xua_server *xs)
| DEFUN (show_cs7_xua, show_cs7_xua_cmd, "show cs7 "XUA_VAR_STR" [<0-65534>]", SHOW_STR CS7_STR XUA_VAR_HELP_STR "Port Number")
| DEFUN (show_cs7_config, show_cs7_config_cmd, "show cs7 config", SHOW_STR CS7_STR "Currently running cs7 configuration")
| DEFUN (cs7_asp, cs7_asp_cmd, "asp NAME <0-65535> <0-65535> " XUA_VAR_STR, "Configure Application Server Process\n" "Name of ASP\n" "Remote SCTP port number\n" "Local SCTP port number\n" XUA_VAR_HELP_STR)
| DEFUN (no_cs7_asp, no_cs7_asp_cmd, "no asp NAME", NO_STR "Disable Application Server Process\n" "Name of ASP\n")
| DEFUN (asp_local_ip, asp_local_ip_cmd, "local-ip A.B.C.D", "Specify Local IP Address from which to contact ASP\n" "Local IP Address from which to contact of ASP\n")
| DEFUN (asp_remote_ip, asp_remote_ip_cmd, "remote-ip A.B.C.D", "Specify Remote IP Address of ASP\n" "Remote IP Address of ASP\n")
| DEFUN (asp_qos_clas, asp_qos_class_cmd, "qos-class <0-255>", "Specify QoS Class of ASP\n" "QoS Class of ASP\n")
| DEFUN (asp_role, asp_role_cmd, "role (sg|asp|ipsp)", "Specify the xUA role for this ASP\n" "SG (Signaling Gateway)\n" "ASP (Application Server Process)\n" "IPSP (IP Signalling Point)\n")
| DEFUN (sctp_role, asp_sctp_role_cmd, "sctp-role (client|server)", "Specify the SCTP role for this ASP\n" "Operate as SCTP client; connect to a server\n" "Operate as SCTP server; wait for client connections\n")
| DEFUN (asp_block, asp_block_cmd, "block", "Allows a SCTP Association with ASP, but doesn't let it become active\n")
| DEFUN (asp_shutdown, asp_shutdown_cmd, "shutdown", "Terminates SCTP association; New associations will be rejected\n")
| DEFUN (show_cs7_asp, show_cs7_asp_cmd, "show cs7 instance <0-15> asp", SHOW_STR CS7_STR INST_STR INST_STR "Application Server Process (ASP)\n")
static void | write_one_asp (struct vty *vty, struct osmo_ss7_asp *asp, bool show_dyn_config)
| DEFUN (cs7_as, cs7_as_cmd, "as NAME " XUA_VAR_STR, "Configure an Application Server\n" "Name of the Application Server\n" XUA_VAR_HELP_STR)
| DEFUN (no_cs7_as, no_cs7_as_cmd, "no as NAME", NO_STR "Disable Application Server\n" "Name of AS\n")
| DEFUN (as_asp, as_asp_cmd, "asp NAME", "Specify that a given ASP is part of this AS\n" "Name of ASP to be added to AS\n")
| DEFUN (as_no_asp, as_no_asp_cmd, "no asp NAME", NO_STR "Specify ASP to be removed from this AS\n" "Name of ASP to be removed\n")
| DEFUN (as_traf_mode, as_traf_mode_cmd, "traffic-mode (broadcast | loadshare | roundrobin | override)", "Specifies traffic mode of operation of the ASP within the AS\n" "Broadcast to all ASP within AS\n" "Share Load among all ASP within AS\n" "Round-Robin between all ASP within AS\n" "Override\n")
| DEFUN (as_no_traf_mode, as_no_traf_mode_cmd, "no traffic-mode", NO_STR "Remove explicit traffic mode of operation of this AS\n")
| DEFUN (as_recov_tout, as_recov_tout_cmd, "recovery-timeout <1-2000>", "Specifies the recovery timeout value in milliseconds\n" "Recovery Timeout in Milliseconds\n")
| DEFUN (as_qos_clas, as_qos_class_cmd, "qos-class <0-255>", "Specity QoS Class of AS\n" "QoS Class of AS\n")
static int | _rout_key (struct vty *vty, const char *rcontext, const char *dpc, const char *si, const char *ssn)
| DEFUN (as_rout_key, as_rout_key_cmd, ROUTING_KEY_CMD, ROUTING_KEY_CMD_STRS)
| DEFUN (as_rout_key_si, as_rout_key_si_cmd, ROUTING_KEY_CMD ROUTING_KEY_SI_ARG, ROUTING_KEY_CMD_STRS ROUTING_KEY_SI_ARG_STRS)
| DEFUN (as_rout_key_ssn, as_rout_key_ssn_cmd, ROUTING_KEY_CMD ROUTING_KEY_SSN_ARG, ROUTING_KEY_CMD_STRS ROUTING_KEY_SSN_ARG_STRS)
| DEFUN (as_rout_key_si_ssn, as_rout_key_si_ssn_cmd, ROUTING_KEY_CMD ROUTING_KEY_SI_ARG ROUTING_KEY_SSN_ARG, ROUTING_KEY_CMD_STRS ROUTING_KEY_SI_ARG_STRS ROUTING_KEY_SSN_ARG_STRS)
| DEFUN (as_pc_override, as_pc_override_cmd, "point-code override dpc PC", "Point Code Specific Features\n" "Override (force) a point-code to hard-coded value\n" "Override Source Point Code\n" "Override Destination Point Code\n" "New Point Code\n")
| DEFUN (as_pc_patch_sccp, as_pc_patch_sccp_cmd, "point-code override patch-sccp (disabled|both)", "Point Code Specific Features\n" "Override (force) a point-code to hard-coded value\n" "Patch point code values into SCCP called/calling address\n" "Don't patch any point codes into SCCP called/calling address\n" "Patch both origin and destination point codes into SCCP called/calling address\n")
static void | write_one_as (struct vty *vty, struct osmo_ss7_as *as, bool show_dyn_config)
| DEFUN (show_cs7_as, show_cs7_as_cmd, "show cs7 instance <0-15> as (active|all|m3ua|sua)", SHOW_STR CS7_STR INST_STR INST_STR "Application Server (AS)\n" "Display all active ASs\n" "Display all ASs (default)\n" "Display all m3ua ASs\n" "Display all SUA ASs\n")
| LLIST_HEAD (sccp_address_book_global)
static struct osmo_sccp_addr_entry * | addr_entry_by_name_local (const char *name, const struct osmo_ss7_instance *inst)
static struct osmo_sccp_addr_entry * | addr_entry_by_name_global (const char *name)
struct osmo_ss7_instance * | osmo_sccp_addr_by_name (struct osmo_sccp_addr *dest_addr, const char *name)
| Lookup an SCCP address from the addressbook by its name. More...
const char * | osmo_sccp_name_by_addr (const struct osmo_sccp_addr *addr)
| Reverse lookup the lookup-name of a specified SCCP address. More...
static void | write_sccp_addressbook (struct vty *vty, const struct osmo_ss7_instance *inst)
| DEFUN (cs7_show_sccpaddr, cs7_show_sccpaddr_cmd, "show cs7 instance <0-15> sccp addressbook", SHOW_STR CS7_STR INST_STR INST_STR SCCP_STR "List all SCCP addressbook entries\n")
| DEFUN (cs7_sccpaddr, cs7_sccpaddr_cmd, "sccp-address NAME", "Create/Modify an SCCP addressbook entry\n" "Name of the SCCP Address\n")
| DEFUN (cs7_sccpaddr_del, cs7_sccpaddr_del_cmd, "no sccp-address NAME", NO_STR "Delete an SCCP addressbook entry\n" "Name of the SCCP Address\n")
| DEFUN (cs7_sccpaddr_ri, cs7_sccpaddr_ri_cmd, "routing-indicator (GT|PC|IP)", "Add Routing Indicator\n" "by global-title\n" "by point-code\n" "by ip-address\n")
| DEFUN (cs7_sccpaddr_pc, cs7_sccpaddr_pc_cmd, "point-code POINT_CODE", "Add point-code Number\n" "PC\n")
| DEFUN (cs7_sccpaddr_pc_del, cs7_sccpaddr_pc_del_cmd, "no point-code", NO_STR "Remove point-code Number\n")
| DEFUN (cs7_sccpaddr_ssn, cs7_sccpaddr_ssn_cmd, "subsystem-number <0-4294967295>", "Add Subsystem Number\n" "SSN\n")
| DEFUN (cs7_sccpaddr_ssn_del, cs7_sccpaddr_ssn_del_cmd, "no subsystem-number", NO_STR "Remove Subsystem Number\n")
| DEFUN (cs7_sccpaddr_gt, cs7_sccpaddr_gt_cmd, "global-title", "Add/Modify Global Title\n")
| DEFUN (cs7_sccpaddr_gt_del, cs7_sccpaddr_gt_del_cmd, "no global-title", NO_STR "Remove Global Title\n")
| DEFUN (cs7_sccpaddr_gt_gti, cs7_sccpaddr_gt_gti_cmd, "global-title-indicator <0-15>", "Set Global Title Indicator\n" "GTI\n")
| DEFUN (cs7_sccpaddr_gt_tt, cs7_sccpaddr_gt_tt_cmd, "translation-type <0-255>", "Set Global Title Translation Type\n" "TT\n")
| DEFUN (cs7_sccpaddr_gt_npi, cs7_sccpaddr_gt_npi_cmd, "numbering-plan-indicator <0-15>", "Set Global Title Numbering Plan Indicator\n" "NPI\n")
| DEFUN (cs7_sccpaddr_gt_nai, cs7_sccpaddr_gt_nai_cmd, "nature-of-address-indicator <0-127>", "Set Global Title Nature of Address Indicator\n" "NAI\n")
| DEFUN (cs7_sccpaddr_gt_digits, cs7_sccpaddr_gt_digits_cmd, "digits DIGITS", "Set Global Title Digits\n" "Number digits\n")
int | osmo_ss7_vty_go_parent (struct vty *vty)
int | osmo_ss7_is_config_node (struct vty *vty, int node)
static void | vty_init_addr (void)
static void | vty_init_shared (void *ctx)
void | osmo_ss7_vty_init_asp (void *ctx)
void | osmo_ss7_vty_init_sg (void *ctx)

## Variables

static enum cs7_role_t | cs7_role
static void * | g_ctx
static struct cmd_node | cs7_node
static const struct value_string | ss7_network_indicator_vals []
static struct cmd_node | rtable_node
static struct cmd_node | xua_node
static struct cmd_node | asp_node
static struct cmd_node | as_node
const struct value_string | mtp_si_vals []
static struct cmd_node | sccpaddr_node
static struct cmd_node | sccpaddr_gt_node

## Macro Definition Documentation

## ROUTING_KEY_CMD

#define ROUTING_KEY_CMD "routing-key RCONTEXT DPC"

## ROUTING_KEY_CMD_STRS

#define ROUTING_KEY_CMD_STRS

Value:
"Define a routing key\n" \
"Routing context number\n" \
"Destination Point Code\n"

## ROUTING_KEY_SI_ARG

#define ROUTING_KEY_SI_ARG " si (aal2|bicc|b-isup|h248|isup|sat-isup|sccp|tup)"

## ROUTING_KEY_SI_ARG_STRS

#define ROUTING_KEY_SI_ARG_STRS

Value:
"Match on Service Indicator\n" \
"ATM Adaption Layer 2\n" \
"Bearer Independent Call Control\n" \
"Broadband ISDN User Part\n" \
"H.248\n" \
"ISDN User Part\n" \
"Sattelite ISDN User Part\n" \
"Signalling Connection Control Part\n" \
"Telephony User Part\n"

## ROUTING_KEY_SSN_ARG

#define ROUTING_KEY_SSN_ARG " ssn SSN"

## ROUTING_KEY_SSN_ARG_STRS

#define ROUTING_KEY_SSN_ARG_STRS

Value:
"Match on Sub-System Number\n" \
"Sub-System Number to match on\n"

## XUA_VAR_HELP_STR

#define XUA_VAR_HELP_STR

Value:
"SCCP User Adaptation\n" \
"MTP3 User Adaptation\n" \
"IPA Multiplex (SCCP Lite)\n"

## XUA_VAR_STR

#define XUA_VAR_STR "(sua|m3ua|ipa)"

## Enumeration Type Documentation

## cs7_role_t

enum cs7_role_t

Enumerator
CS7_ROLE_SG |
CS7_ROLE_ASP |

## Function Documentation

## _rout_key()

static int _rout_key | ( | struct vty * | vty,
|  | const char * | rcontext,
|  | const char * | dpc,
|  | const char * | si,
|  | const char * | ssn
| ) |  |

static

References osmo_ss7_as::cfg, osmo_ss7_routing_key::context, dpc, osmo_ss7_as::inst, mtp_si_vals, OSMO_SS7_ASP_PROT_IPA, osmo_ss7_pointcode_parse(), osmo_ss7_routing_key::pc, osmo_ss7_as::proto, osmo_ss7_as::routing_key, osmo_ss7_routing_key::si, si, and osmo_ss7_routing_key::ssn.

Referenced by DEFUN().

## addr_entry_by_name_global()

static struct osmo_sccp_addr_entry* addr_entry_by_name_global | ( | const char * | name | ) |

static

References osmo_sccp_addr_entry::list_global, and osmo_sccp_addr_entry::name.

Referenced by DEFUN(), and osmo_sccp_addr_by_name().

## addr_entry_by_name_local()

static struct osmo_sccp_addr_entry* addr_entry_by_name_local | ( | const char * | name,
|  | const struct osmo_ss7_instance * | inst
| ) |  |

static

References osmo_ss7_instance::cfg, osmo_sccp_addr_entry::inst, osmo_sccp_addr_entry::list, osmo_sccp_addr_entry::name, and osmo_ss7_instance::sccp_address_book.

Referenced by DEFUN().

## config_write_cs7()

static int config_write_cs7 | ( | struct vty * | vty | ) |

static

References write_all_cs7().

Referenced by vty_init_shared().

## DEFUN() [1/58]

DEFUN | ( | as_asp | ,
|  | as_asp_cmd | ,
|  | "asp NAME" | ,
|  | "Specify that a given ASP is part of this AS\n" "Name of ASP to be added to AS\n" |
| ) |  |

References osmo_ss7_as_add_asp().

## DEFUN() [2/58]

DEFUN | ( | as_no_asp | ,
|  | as_no_asp_cmd | ,
|  | "no asp NAME" | ,
|  | NO_STR "Specify ASP to be removed from this AS\n" "Name of ASP to be removed\n" |
| ) |  |

References osmo_ss7_as_del_asp().

## DEFUN() [3/58]

DEFUN | ( | as_no_traf_mode | ,
|  | as_no_traf_mode_cmd | ,
|  | "no traffic-mode" | ,
|  | NO_STR "Remove explicit traffic mode of operation of this AS\n" |
| ) |  |

References osmo_ss7_as::cfg, osmo_ss7_as::mode, and osmo_ss7_as::mode_set_by_vty.

## DEFUN() [4/58]

DEFUN | ( | as_pc_override | ,
|  | as_pc_override_cmd | ,
|  | "point-code override dpc PC" | ,
|  | "Point Code Specific Features\n" "Override (force) a point-code to hard-coded value\n" "Override Source Point Code\n" "Override Destination Point Code\n" "New Point Code\n" |
| ) |  |

References osmo_ss7_as::cfg, osmo_ss7_as::inst, OSMO_SS7_ASP_PROT_IPA, osmo_ss7_pointcode_parse(), osmo_ss7_as::pc_override, and osmo_ss7_as::proto.

## DEFUN() [5/58]

DEFUN | ( | as_pc_patch_sccp | ,
|  | as_pc_patch_sccp_cmd | ,
|  | "point-code override patch-sccp (disabled|both)" | ,
|  | "Point Code Specific Features\n" "Override (force) a point-code to hard-coded value\n" "Patch point code values into SCCP called/calling address\n" "Don't patch any point codes into SCCP called/calling address\n" "Patch both origin and destination point codes into SCCP called/calling address\n" |
| ) |  |

References osmo_ss7_as::cfg, OSMO_SS7_ASP_PROT_IPA, OSMO_SS7_PATCH_BOTH, OSMO_SS7_PATCH_NONE, osmo_ss7_as::pc_override, and osmo_ss7_as::proto.

## DEFUN() [6/58]

DEFUN | ( | as_qos_clas | ,
|  | as_qos_class_cmd | ,
|  | "qos-class <0-255>" | ,
|  | "Specity QoS Class of AS\n" "QoS Class of AS\n" |
| ) |  |

References osmo_ss7_as::cfg, and osmo_ss7_as::qos_class.

## DEFUN() [7/58]

DEFUN | ( | as_recov_tout | ,
|  | as_recov_tout_cmd | ,
|  | "recovery-timeout <1-2000>" | ,
|  | "Specifies the recovery timeout value in milliseconds\n" "Recovery Timeout in Milliseconds\n" |
| ) |  |

References osmo_ss7_as::cfg, and osmo_ss7_as::recovery_timeout_msec.

## DEFUN() [8/58]

DEFUN | ( | as_rout_key | ,
|  | as_rout_key_cmd | ,
|  | ROUTING_KEY_CMD | ,
|  | ROUTING_KEY_CMD_STRS |
| ) |  |

References _rout_key().

## DEFUN() [9/58]

DEFUN | ( | as_rout_key_si | ,
|  | as_rout_key_si_cmd | ,
|  | ROUTING_KEY_CMD | ROUTING_KEY_SI_ARG,
|  | ROUTING_KEY_CMD_STRS | ROUTING_KEY_SI_ARG_STRS
| ) |  |

References _rout_key().

## DEFUN() [10/58]

DEFUN | ( | as_rout_key_si_ssn | ,
|  | as_rout_key_si_ssn_cmd | ,
|  | ROUTING_KEY_CMD ROUTING_KEY_SI_ARG | ROUTING_KEY_SSN_ARG,
|  | ROUTING_KEY_CMD_STRS ROUTING_KEY_SI_ARG_STRS | ROUTING_KEY_SSN_ARG_STRS
| ) |  |

References _rout_key().

## DEFUN() [11/58]

DEFUN | ( | as_rout_key_ssn | ,
|  | as_rout_key_ssn_cmd | ,
|  | ROUTING_KEY_CMD | ROUTING_KEY_SSN_ARG,
|  | ROUTING_KEY_CMD_STRS | ROUTING_KEY_SSN_ARG_STRS
| ) |  |

References _rout_key().

## DEFUN() [12/58]

DEFUN | ( | as_traf_mode | ,
|  | as_traf_mode_cmd | ,
|  | "traffic-mode (broadcast | loadshare | roundrobin | override)" | ,
|  | "Specifies traffic mode of operation of the ASP within the AS\n" "Broadcast to all ASP within AS\n" "Share Load among all ASP within AS\n" "Round-Robin between all ASP within AS\n" "Override\n" |
| ) |  |

References osmo_ss7_as::cfg, osmo_ss7_as::mode, osmo_ss7_as::mode_set_by_vty, and osmo_ss7_as_traffic_mode_vals.

## DEFUN() [13/58]

DEFUN | ( | asp_block | ,
|  | asp_block_cmd | ,
|  | "block" | ,
|  | "Allows a SCTP Association with | ASP,
|  | but doesn 't let it become active\n" |
| ) |  |

## DEFUN() [14/58]

DEFUN | ( | asp_local_ip | ,
|  | asp_local_ip_cmd | ,
|  | "local-ip A.B.C.D" | ,
|  | "Specify Local IP Address from which to contact ASP\n" "Local IP Address from which to contact of ASP\n" |
| ) |  |

References osmo_ss7_asp::cfg, osmo_ss7_asp::local, and osmo_ss7_asp_peer_add_host().

## DEFUN() [15/58]

DEFUN | ( | asp_qos_clas | ,
|  | asp_qos_class_cmd | ,
|  | "qos-class <0-255>" | ,
|  | "Specify QoS Class of ASP\n" "QoS Class of ASP\n" |
| ) |  |

References osmo_ss7_asp::cfg, and osmo_ss7_asp::qos_class.

## DEFUN() [16/58]

DEFUN | ( | asp_remote_ip | ,
|  | asp_remote_ip_cmd | ,
|  | "remote-ip A.B.C.D" | ,
|  | "Specify Remote IP Address of ASP\n" "Remote IP Address of ASP\n" |
| ) |  |

References osmo_ss7_asp::cfg, osmo_ss7_asp_peer_add_host(), and osmo_ss7_asp::remote.

## DEFUN() [17/58]

DEFUN | ( | asp_role | ,
|  | asp_role_cmd | ,
|  | "role (sg|asp|ipsp)" | ,
|  | "Specify the xUA role for this ASP\n" "SG (Signaling Gateway)\n" "ASP (Application Server Process)\n" "IPSP (IP Signalling Point)\n" |
| ) |  |

References osmo_ss7_asp::cfg, OSMO_SS7_ASP_ROLE_ASP, OSMO_SS7_ASP_ROLE_SG, osmo_ss7_asp::role, and osmo_ss7_asp::role_set_by_vty.

## DEFUN() [18/58]

DEFUN | ( | asp_shutdown | ,
|  | asp_shutdown_cmd | ,
|  | "shutdown" | ,
|  | "Terminates SCTP association; New associations will be rejected\n" |
| ) |  |

## DEFUN() [19/58]

DEFUN | ( | cs7_as | ,
|  | cs7_as_cmd | ,
|  | "as NAME " | XUA_VAR_STR,
|  | "Configure an Application Server\n" "Name of the Application Server\n" | XUA_VAR_HELP_STR
| ) |  |

References osmo_ss7_as::cfg, osmo_ss7_as::description, osmo_ss7_as::inst, osmo_ss7_as::name, osmo_ss7_as_find_or_create(), OSMO_SS7_ASP_PROT_NONE, and parse_asp_proto().

## DEFUN() [20/58]

DEFUN | ( | cs7_asp | ,
|  | cs7_asp_cmd | ,
|  | "asp NAME <0-65535> <0-65535> " | XUA_VAR_STR,
|  | "Configure Application Server Process\n" "Name of ASP\n" "Remote SCTP port number\n" "Local SCTP port number\n" | XUA_VAR_HELP_STR
| ) |  |

References osmo_ss7_asp::cfg, osmo_ss7_asp::description, osmo_ss7_asp::inst, osmo_ss7_asp::is_server, osmo_ss7_instance::name, osmo_ss7_asp::name, osmo_ss7_asp_find(), osmo_ss7_asp_find_or_create(), OSMO_SS7_ASP_PROT_NONE, OSMO_SS7_ASP_ROLE_SG, parse_asp_proto(), and osmo_ss7_asp::role.

## DEFUN() [21/58]

DEFUN | ( | cs7_instance | ,
|  | cs7_instance_cmd | ,
|  | "cs7 instance <0-15>" | ,
|  | CS7_STR "Configure a SS7 Instance\n" INST_STR "Number of the instance\n" |
| ) |  |

References osmo_ss7_instance::cfg, osmo_ss7_instance::description, g_ctx, and osmo_ss7_instance_find_or_create().

## DEFUN() [22/58]

DEFUN | ( | cs7_net_ind | ,
|  | cs7_net_ind_cmd | ,
|  | "network-indicator (international | national | reserved | spare)" | ,
|  | "Configure the Network Indicator\n" "International Network\n" "National Network\n" "Reserved Network\n" "Spare Network\n" |
| ) |  |

References osmo_ss7_instance::cfg, osmo_ss7_instance::network_indicator, ni, and ss7_network_indicator_vals.

## DEFUN() [23/58]

DEFUN | ( | cs7_pc_delimiter | ,
|  | cs7_pc_delimiter_cmd | ,
|  | "point-code delimiter (default|dash)" | ,
|  | PC_STR "Configure Point Code Delimiter\n" "Use dot as delimiter\n" "User dash as delimiter\n" |
| ) |  |

References osmo_ss7_instance::cfg, osmo_ss7_pc_fmt::delimiter, and osmo_ss7_instance::pc_fmt.

## DEFUN() [24/58]

DEFUN | ( | cs7_pc_format | ,
|  | cs7_pc_format_cmd | ,
|  | "point-code format <1-24> " | [< 1-23 >][< 1-22 >],
|  | PC_STR "Configure Point Code Format\n" "Length of first PC component\n" "Length of second PC component\n" "Length of third PC component\n" |
| ) |  |

References osmo_ss7_instance::cfg, osmo_ss7_pc_fmt::component_len, and osmo_ss7_instance::pc_fmt.

## DEFUN() [25/58]

DEFUN | ( | cs7_pc_format_def | ,
|  | cs7_pc_format_def_cmd | ,
|  | "point-code format default" | ,
|  | PC_STR "Configure Point Code Format\n" "Default Point Code Format (3.8.3)\n" |
| ) |  |

References osmo_ss7_instance::cfg, osmo_ss7_pc_fmt::component_len, and osmo_ss7_instance::pc_fmt.

## DEFUN() [26/58]

DEFUN | ( | cs7_permit_dyn_rkm | ,
|  | cs7_permit_dyn_rkm_cmd | ,
|  | "xua rkm routing-key-allocation (static-only|dynamic-permitted)" | ,
|  | "SIGTRAN xxxUA related\n" "Routing Key Management\n" "Routing Key Management Allocation Policy\n" "Only static (pre-confgured) Routing Keys permitted\n" "Dynamically allocate Routing Keys for what ASPs request\n" |
| ) |  |

References osmo_ss7_instance::cfg, and osmo_ss7_instance::permit_dyn_rkm_alloc.

## DEFUN() [27/58]

DEFUN | ( | cs7_point_code | ,
|  | cs7_point_code_cmd | ,
|  | "point-code POINT_CODE" | ,
|  | "Configure the local Point Code\n" "Point Code\n" |
| ) |  |

References osmo_ss7_instance::cfg, osmo_ss7_pc_is_valid(), osmo_ss7_pointcode_parse(), and osmo_ss7_instance::primary_pc.

## DEFUN() [28/58]

DEFUN | ( | cs7_route_table | ,
|  | cs7_route_table_cmd | ,
|  | "route-table system" | ,
|  | "Specify the name of the route table\n" "Name of the route table\n" |
| ) |  |

References osmo_ss7_route_table::cfg, osmo_ss7_route_table::description, osmo_ss7_route_table::inst, and osmo_ss7_instance::rtable_system.

## DEFUN() [29/58]

DEFUN | ( | cs7_rt_rem | ,
|  | cs7_rt_rem_cmd | ,
|  | "remove route POINT_CODE MASK" | ,
|  | "Remove a Route\n" "Remove a Route\n" "Destination Point Code\n" "Point Code Mask\n" "Point Code Length\n" |
| ) |  |

References dpc, osmo_ss7_route_table::inst, osmo_ss7_route::mask, osmo_ss7_pointcode_parse(), osmo_ss7_pointcode_parse_mask_or_len(), osmo_ss7_route_destroy(), osmo_ss7_route_find_dpc_mask(), and osmo_ss7_route::rtable.

## DEFUN() [30/58]

DEFUN | ( | cs7_rt_upd | ,
|  | cs7_rt_upd_cmd | ,
|  | "update route POINT_CODE MASK linkset LS_NAME " | [priority PRIO][qos-class(CLASS|default)],
|  | "Update the Route\n" "Update the Route\n" "Destination Point Code\n" "Point Code Mask\n" "Point Code Length\n" "Specify Destination Linkset\n" "Linkset Name\n" "Specify Priority\n" "Priority\n" "Specify QoS Class\n" "QoS Class\n" "Default QoS Class\n" |
| ) |  |

References osmo_ss7_route::cfg, dpc, osmo_ss7_route_table::inst, osmo_ss7_route::mask, osmo_ss7_pointcode_parse(), osmo_ss7_pointcode_parse_mask_or_len(), osmo_ss7_route_create(), osmo_ss7_route::priority, osmo_ss7_route::qos_class, and osmo_ss7_route::rtable.

## DEFUN() [31/58]

DEFUN | ( | cs7_sccpaddr | ,
|  | cs7_sccpaddr_cmd | ,
|  | "sccp-address NAME" | ,
|  | "Create/Modify an SCCP addressbook entry\n" "Name of the SCCP Address\n" |
| ) |  |

References addr_entry_by_name_global(), addr_entry_by_name_local(), osmo_ss7_instance::cfg, osmo_ss7_instance::name, OSMO_SCCP_RI_SSN_PC, and osmo_ss7_instance::sccp_address_book.

## DEFUN() [32/58]

DEFUN | ( | cs7_sccpaddr_del | ,
|  | cs7_sccpaddr_del_cmd | ,
|  | "no sccp-address NAME" | ,
|  | NO_STR "Delete an SCCP addressbook entry\n" "Name of the SCCP Address\n" |
| ) |  |

References addr_entry_by_name_local(), and osmo_ss7_instance::name.

## DEFUN() [33/58]

DEFUN | ( | cs7_sccpaddr_gt | ,
|  | cs7_sccpaddr_gt_cmd | ,
|  | "global-title" | ,
|  | "Add/Modify Global Title\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, OSMO_SCCP_ADDR_T_GT, and osmo_sccp_addr::presence.

## DEFUN() [34/58]

DEFUN | ( | cs7_sccpaddr_gt_del | ,
|  | cs7_sccpaddr_gt_del_cmd | ,
|  | "no global-title" | ,
|  | NO_STR "Remove Global Title\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, osmo_sccp_addr::gt, OSMO_SCCP_ADDR_T_GT, and osmo_sccp_addr::presence.

## DEFUN() [35/58]

DEFUN | ( | cs7_sccpaddr_gt_digits | ,
|  | cs7_sccpaddr_gt_digits_cmd | ,
|  | "digits DIGITS" | ,
|  | "Set Global Title Digits\n" "Number digits\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, osmo_sccp_gt::digits, and osmo_sccp_addr::gt.

## DEFUN() [36/58]

DEFUN | ( | cs7_sccpaddr_gt_gti | ,
|  | cs7_sccpaddr_gt_gti_cmd | ,
|  | "global-title-indicator <0-15>" | ,
|  | "Set Global Title Indicator\n" "GTI\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, osmo_sccp_addr::gt, and osmo_sccp_gt::gti.

## DEFUN() [37/58]

DEFUN | ( | cs7_sccpaddr_gt_nai | ,
|  | cs7_sccpaddr_gt_nai_cmd | ,
|  | "nature-of-address-indicator <0-127>" | ,
|  | "Set Global Title Nature of Address Indicator\n" "NAI\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, osmo_sccp_addr::gt, and osmo_sccp_gt::nai.

## DEFUN() [38/58]

DEFUN | ( | cs7_sccpaddr_gt_npi | ,
|  | cs7_sccpaddr_gt_npi_cmd | ,
|  | "numbering-plan-indicator <0-15>" | ,
|  | "Set Global Title Numbering Plan Indicator\n" "NPI\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, osmo_sccp_addr::gt, and osmo_sccp_gt::npi.

## DEFUN() [39/58]

DEFUN | ( | cs7_sccpaddr_gt_tt | ,
|  | cs7_sccpaddr_gt_tt_cmd | ,
|  | "translation-type <0-255>" | ,
|  | "Set Global Title Translation Type\n" "TT\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, osmo_sccp_addr::gt, and osmo_sccp_gt::tt.

## DEFUN() [40/58]

DEFUN | ( | cs7_sccpaddr_pc | ,
|  | cs7_sccpaddr_pc_cmd | ,
|  | "point-code POINT_CODE" | ,
|  | "Add point-code Number\n" "PC\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, osmo_sccp_addr_entry::inst, OSMO_SCCP_ADDR_T_PC, OSMO_SCCP_RI_NONE, OSMO_SCCP_RI_SSN_PC, osmo_ss7_pointcode_parse(), osmo_sccp_addr::pc, osmo_sccp_addr::presence, and osmo_sccp_addr::ri.

## DEFUN() [41/58]

DEFUN | ( | cs7_sccpaddr_pc_del | ,
|  | cs7_sccpaddr_pc_del_cmd | ,
|  | "no point-code" | ,
|  | NO_STR "Remove point-code Number\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, OSMO_SCCP_ADDR_T_PC, osmo_sccp_addr::pc, and osmo_sccp_addr::presence.

## DEFUN() [42/58]

DEFUN | ( | cs7_sccpaddr_ri | ,
|  | cs7_sccpaddr_ri_cmd | ,
|  | "routing-indicator (GT|PC|IP)" | ,
|  | "Add Routing Indicator\n" "by global-title\n" "by point-code\n" "by ip-address\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, OSMO_SCCP_RI_GT, OSMO_SCCP_RI_SSN_IP, OSMO_SCCP_RI_SSN_PC, and osmo_sccp_addr::ri.

## DEFUN() [43/58]

DEFUN | ( | cs7_sccpaddr_ssn | ,
|  | cs7_sccpaddr_ssn_cmd | ,
|  | "subsystem-number <0-4294967295>" | ,
|  | "Add Subsystem Number\n" "SSN\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, OSMO_SCCP_ADDR_T_SSN, osmo_sccp_addr::presence, and osmo_sccp_addr::ssn.

## DEFUN() [44/58]

DEFUN | ( | cs7_sccpaddr_ssn_del | ,
|  | cs7_sccpaddr_ssn_del_cmd | ,
|  | "no subsystem-number" | ,
|  | NO_STR "Remove Subsystem Number\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, OSMO_SCCP_ADDR_T_SSN, osmo_sccp_addr::presence, and osmo_sccp_addr::ssn.

## DEFUN() [45/58]

DEFUN | ( | cs7_show_sccpaddr | ,
|  | cs7_show_sccpaddr_cmd | ,
|  | "show cs7 instance <0-15> sccp addressbook" | ,
|  | SHOW_STR CS7_STR INST_STR INST_STR SCCP_STR "List all SCCP addressbook entries\n" |
| ) |  |

References osmo_sccp_addr_entry::addr, osmo_ss7_instance::cfg, osmo_ss7_instance::description, osmo_sccp_gt::digits, osmo_sccp_addr::gt, osmo_sccp_gt::gti, osmo_sccp_addr_entry::inst, osmo_sccp_addr::ip, osmo_sccp_addr_entry::list, osmo_sccp_gt::nai, osmo_sccp_addr_entry::name, osmo_sccp_gt::npi, OSMO_SCCP_ADDR_T_GT, OSMO_SCCP_ADDR_T_IPv4, OSMO_SCCP_ADDR_T_IPv6, OSMO_SCCP_ADDR_T_PC, OSMO_SCCP_ADDR_T_SSN, OSMO_SCCP_RI_GT, OSMO_SCCP_RI_SSN_IP, OSMO_SCCP_RI_SSN_PC, osmo_ss7_instance_find(), osmo_ss7_pointcode_print(), osmo_sccp_addr::pc, osmo_sccp_addr::presence, osmo_sccp_addr::ri, osmo_ss7_instance::sccp_address_book, osmo_sccp_addr::ssn, osmo_sccp_gt::tt, osmo_sccp_addr::v4, and osmo_sccp_addr::v6.

## DEFUN() [46/58]

DEFUN | ( | cs7_xua | ,
|  | cs7_xua_cmd | ,
|  | "listen " XUA_VAR_STR " <0-65534>" | ,
|  | "Configure/Enable xUA Listener\n" XUA_VAR_HELP_STR "SCTP Port number\n" |
| ) |  |

References osmo_xua_server::inst, osmo_ss7_xua_server_create(), osmo_ss7_xua_server_find(), osmo_ss7_xua_server_set_local_hosts(), parse_asp_proto(), and osmo_xua_server::proto.

## DEFUN() [47/58]

DEFUN | ( | no_cs7_as | ,
|  | no_cs7_as_cmd | ,
|  | "no as NAME" | ,
|  | NO_STR "Disable Application Server\n" "Name of AS\n" |
| ) |  |

References osmo_ss7_as::inst, osmo_ss7_instance::name, osmo_ss7_as::name, osmo_ss7_as_destroy(), and osmo_ss7_as_find_by_name().

## DEFUN() [48/58]

DEFUN | ( | no_cs7_asp | ,
|  | no_cs7_asp_cmd | ,
|  | "no asp NAME" | ,
|  | NO_STR "Disable Application Server Process\n" "Name of ASP\n" |
| ) |  |

References osmo_ss7_asp::inst, osmo_ss7_instance::name, osmo_ss7_asp::name, osmo_ss7_asp_destroy(), and osmo_ss7_asp_find_by_name().

## DEFUN() [49/58]

DEFUN | ( | no_cs7_xua | ,
|  | no_cs7_xua_cmd | ,
|  | "no listen " XUA_VAR_STR " <0-65534>" | ,
|  | NO_STR "Disable xUA Listener on given SCTP Port\n" XUA_VAR_HELP_STR "SCTP Port number\n" |
| ) |  |

References osmo_xua_server::inst, osmo_ss7_xua_server_destroy(), osmo_ss7_xua_server_find(), parse_asp_proto(), and osmo_xua_server::proto.

## DEFUN() [50/58]

DEFUN | ( | sctp_role | ,
|  | asp_sctp_role_cmd | ,
|  | "sctp-role (client|server)" | ,
|  | "Specify the SCTP role for this ASP\n" "Operate as SCTP client; connect to a server\n" "Operate as SCTP server; wait for client connections\n" |
| ) |  |

References osmo_ss7_asp::cfg, and osmo_ss7_asp::is_server.

## DEFUN() [51/58]

DEFUN | ( | show_cs7_as | ,
|  | show_cs7_as_cmd | ,
|  | "show cs7 instance <0-15> as (active|all|m3ua|sua)" | ,
|  | SHOW_STR CS7_STR INST_STR INST_STR "Application Server (AS)\n" "Display all active ASs\n" "Display all ASs (default)\n" "Display all m3ua ASs\n" "Display all SUA ASs\n" |
| ) |  |

References osmo_ss7_instance::as_list, osmo_ss7_as::cfg, osmo_ss7_routing_key::context, osmo_ss7_as::fi, osmo_ss7_as::inst, osmo_ss7_as::list, osmo_ss7_as::mode, osmo_ss7_as::name, osmo_ss7_as_active(), osmo_ss7_as_traffic_mode_name(), OSMO_SS7_ASP_PROT_M3UA, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_instance_find(), osmo_ss7_pointcode_print(), osmo_ss7_routing_key::pc, osmo_ss7_as::proto, and osmo_ss7_as::routing_key.

## DEFUN() [52/58]

DEFUN | ( | show_cs7_asp | ,
|  | show_cs7_asp_cmd | ,
|  | "show cs7 instance <0-15> asp" | ,
|  | SHOW_STR CS7_STR INST_STR INST_STR "Application Server Process (ASP)\n" |
| ) |  |

References osmo_ss7_instance::asp_list, osmo_ss7_asp::cfg, osmo_ss7_asp::fi, osmo_ss7_asp::inst, osmo_ss7_asp::list, osmo_ss7_asp::name, osmo_ss7_asp_peer_snprintf(), osmo_ss7_asp_protocol_vals, osmo_ss7_instance_find(), osmo_ss7_asp::proto, and osmo_ss7_asp::remote.

## DEFUN() [53/58]

DEFUN | ( | show_cs7_config | ,
|  | show_cs7_config_cmd | ,
|  | "show cs7 config" | ,
|  | SHOW_STR CS7_STR "Currently running cs7 configuration" |
| ) |  |

## DEFUN() [54/58]

DEFUN | ( | show_cs7_route | ,
|  | show_cs7_route_cmd | ,
|  | "show cs7 instance <0-15> route" | ,
|  | SHOW_STR CS7_STR INST_STR INST_STR "Routing Table\n" |
| ) |  |

References osmo_ss7_instance_find(), osmo_ss7_instance::rtable_system, and vty_dump_rtable().

## DEFUN() [55/58]

DEFUN | ( | show_cs7_user | ,
|  | show_cs7_user_cmd | ,
|  | "show cs7 instance <0-15> users" | ,
|  | SHOW_STR CS7_STR INST_STR INST_STR "User Table\n" |
| ) |  |

References osmo_ss7_user::inst, osmo_ss7_user::name, osmo_ss7_instance_find(), and osmo_ss7_instance::user.

## DEFUN() [56/58]

DEFUN | ( | show_cs7_xua | ,
|  | show_cs7_xua_cmd | ,
|  | "show cs7 "XUA_VAR_STR" " | [< 0-65534 >],
|  | SHOW_STR CS7_STR XUA_VAR_HELP_STR "Port Number" |
| ) |  |

References osmo_xua_server::cfg, osmo_xua_server::inst, osmo_xua_server::list, osmo_ss7_instances, osmo_ss7_xua_server_find(), parse_asp_proto(), osmo_xua_server::proto, vty_dump_xua_server(), and osmo_ss7_instance::xua_servers.

## DEFUN() [57/58]

DEFUN | ( | xua_accept_dyn_asp | ,
|  | xua_accept_dyn_asp_cmd | ,
|  | "accept-asp-connections (pre-configured|dynamic-permitted)" | ,
|  | "Define what kind of ASP connections to accept\n" "Accept only pre-confiugred ASPs (source IP/prt)\n" "Accept any connection and dynamically create an ASP definition\n" |
| ) |  |

References osmo_xua_server::accept_dyn_reg, and osmo_xua_server::cfg.

## DEFUN() [58/58]

DEFUN | ( | xua_local_ip | ,
|  | xua_local_ip_cmd | ,
|  | "local-ip A.B.C.D" | ,
|  | "Configure the Local IP Address for xUA\n" "IP Address to use for XUA\n" |
| ) |  |

References osmo_ss7_xua_server_add_local_host().

## LLIST_HEAD()

LLIST_HEAD | ( | sccp_address_book_global |  | ) |

## osmo_sccp_addr_by_name()

struct osmo_ss7_instance* osmo_sccp_addr_by_name | ( | struct osmo_sccp_addr * | dest_addr,
|  | const char * | name
| ) |  |

Lookup an SCCP address from the addressbook by its name.

Parameters

  [out] | dest_addr | pointer to output the resulting sccp-address; (set to NULL if not interested)
  [in] | name | of the address to lookup

Returns
  SS7 instance; NULL on error

References osmo_sccp_addr_entry::addr, addr_entry_by_name_global(), osmo_sccp_addr_entry::inst, and osmo_sccp_addr_entry::name.

## osmo_sccp_name_by_addr()

const char* osmo_sccp_name_by_addr | ( | const struct osmo_sccp_addr * | addr | ) |

Reverse lookup the lookup-name of a specified SCCP address.

Parameters

  [in] | name | of the address to lookup

Returns
  char pointer to the lookup-name; NULL on error

References osmo_sccp_addr_entry::addr, osmo_sccp_addr_entry::list_global, and osmo_sccp_addr_entry::name.

## osmo_ss7_is_config_node()

int osmo_ss7_is_config_node | ( | struct vty * | vty,
|  | int | node
| ) |  |

## osmo_ss7_vty_go_parent()

int osmo_ss7_vty_go_parent | ( | struct vty * | vty | ) |

References osmo_ss7_asp::cfg, osmo_xua_server::cfg, osmo_ss7_asp_peer::host_cnt, osmo_ss7_route_table::inst, osmo_ss7_as::inst, osmo_ss7_asp::inst, osmo_xua_server::inst, osmo_sccp_addr_entry::inst, osmo_ss7_asp::local, osmo_xua_server::local, osmo_ss7_asp_peer_add_host(), osmo_ss7_asp_restart(), osmo_ss7_xua_server_bind(), osmo_ss7_xua_server_set_local_host(), and osmo_ss7_asp::remote.

## osmo_ss7_vty_init_asp()

void osmo_ss7_vty_init_asp | ( | void * | ctx | ) |

References cs7_role, CS7_ROLE_ASP, and vty_init_shared().

## osmo_ss7_vty_init_sg()

void osmo_ss7_vty_init_sg | ( | void * | ctx | ) |

## parse_asp_proto()

static enum osmo_ss7_asp_protocol parse_asp_proto | ( | const char * | protocol | ) |

static

Referenced by DEFUN().

## vty_dump_rtable()

static void vty_dump_rtable | ( | struct vty * | vty,
|  | struct osmo_ss7_route_table * | rtbl
| ) |  |

static

References osmo_ss7_route_table::cfg, osmo_ss7_route::cfg, osmo_ss7_route::linkset_name, osmo_ss7_route::list, osmo_ss7_route_table::name, osmo_ss7_route_print(), osmo_ss7_route::priority, and osmo_ss7_route_table::routes.

Referenced by DEFUN().

## vty_dump_xua_server()

static void vty_dump_xua_server | ( | struct vty * | vty,
|  | struct osmo_xua_server * | xs
| ) |  |

static

References osmo_xua_server::cfg, osmo_xua_server::local, osmo_ss7_asp_peer_snprintf(), osmo_ss7_asp_protocol_vals, and osmo_xua_server::proto.

Referenced by DEFUN().

## vty_init_addr()

static void vty_init_addr | ( | void |  | ) |

static

References sccpaddr_gt_node, and sccpaddr_node.

Referenced by vty_init_shared().

## vty_init_shared()

static void vty_init_shared | ( | void * | ctx | ) |

static

References as_node, asp_node, config_write_cs7(), cs7_node, g_ctx, and vty_init_addr().

Referenced by osmo_ss7_vty_init_asp().

## write_all_cs7()

static int write_all_cs7 | ( | struct vty * | vty,
|  | bool | show_dyn_config
| ) |  |

static

References osmo_ss7_instance::list, osmo_ss7_instances, and write_one_cs7().

Referenced by config_write_cs7().

## write_one_as()

static void write_one_as | ( | struct vty * | vty,
|  | struct osmo_ss7_as * | as,
|  | bool | show_dyn_config
| ) |  |

static

References osmo_ss7_as::asps, osmo_ss7_as::cfg, osmo_ss7_asp::cfg, osmo_ss7_routing_key::context, osmo_ss7_as::description, osmo_ss7_asp::dyn_allocated, osmo_ss7_as::inst, osmo_ss7_as::mode, osmo_ss7_as::mode_set_by_vty, mtp_si_vals, osmo_ss7_as::name, osmo_ss7_asp::name, osmo_ss7_as_traffic_mode_name(), osmo_ss7_asp_protocol_name(), osmo_ss7_pointcode_print(), osmo_ss7_routing_key::pc, osmo_ss7_as::pc_override, osmo_ss7_as::proto, osmo_ss7_as::qos_class, osmo_ss7_as::recovery_timeout_msec, osmo_ss7_as::rkm_dyn_allocated, osmo_ss7_as::routing_key, osmo_ss7_routing_key::si, osmo_ss7_as::simple_client_allocated, osmo_ss7_asp::simple_client_allocated, and osmo_ss7_routing_key::ssn.

Referenced by write_one_cs7().

## write_one_asp()

static void write_one_asp | ( | struct vty * | vty,
|  | struct osmo_ss7_asp * | asp,
|  | bool | show_dyn_config
| ) |  |

static

Referenced by write_one_cs7().

## write_one_cs7()

static void write_one_cs7 | ( | struct vty * | vty,
|  | struct osmo_ss7_instance * | inst,
|  | bool | show_dyn_config
| ) |  |

static

References osmo_ss7_instance::as_list, osmo_ss7_instance::asp_list, osmo_ss7_instance::cfg, osmo_ss7_pc_fmt::component_len, cs7_role, CS7_ROLE_SG, osmo_ss7_pc_fmt::delimiter, osmo_ss7_instance::description, osmo_ss7_instance::id, osmo_xua_server::inst, osmo_xua_server::list, osmo_ss7_instance::network_indicator, osmo_sccp_vty_write_cs7_node(), osmo_ss7_pc_is_valid(), osmo_ss7_pointcode_print(), osmo_ss7_instance::pc_fmt, osmo_ss7_instance::permit_dyn_rkm_alloc, osmo_ss7_instance::primary_pc, osmo_ss7_instance::rtable_list, osmo_ss7_instance::sccp, ss7_network_indicator_vals, write_one_as(), write_one_asp(), write_one_rtable(), write_one_xua(), write_sccp_addressbook(), and osmo_ss7_instance::xua_servers.

Referenced by write_all_cs7().

## write_one_rtable()

static void write_one_rtable | ( | struct vty * | vty,
|  | struct osmo_ss7_route_table * | rtable
| ) |  |

static

References osmo_ss7_route_table::cfg, osmo_ss7_route::cfg, osmo_ss7_route_table::description, osmo_ss7_route_table::inst, osmo_ss7_route::linkset_name, osmo_ss7_route::list, osmo_ss7_route::mask, osmo_ss7_route_table::name, osmo_ss7_pointcode_print(), osmo_ss7_pointcode_print2(), osmo_ss7_route::pc, osmo_ss7_route::priority, osmo_ss7_route::qos_class, osmo_ss7_route_table::routes, and osmo_ss7_route::rtable.

Referenced by write_one_cs7().

## write_one_xua()

static void write_one_xua | ( | struct vty * | vty,
|  | struct osmo_xua_server * | xs
| ) |  |

static

References osmo_xua_server::accept_dyn_reg, osmo_xua_server::cfg, osmo_ss7_asp_peer::host, osmo_ss7_asp_peer::host_cnt, osmo_xua_server::local, osmo_ss7_asp_protocol_vals, osmo_ss7_asp_peer::port, and osmo_xua_server::proto.

Referenced by write_one_cs7().

## write_sccp_addressbook()

static void write_sccp_addressbook | ( | struct vty * | vty,
|  | const struct osmo_ss7_instance * | inst
| ) |  |

static

References osmo_sccp_addr_entry::addr, osmo_ss7_instance::cfg, osmo_sccp_gt::digits, osmo_sccp_addr::gt, osmo_sccp_gt::gti, osmo_sccp_addr_entry::inst, osmo_sccp_addr_entry::list, osmo_sccp_gt::nai, osmo_sccp_addr_entry::name, osmo_sccp_gt::npi, OSMO_SCCP_ADDR_T_GT, OSMO_SCCP_ADDR_T_PC, OSMO_SCCP_ADDR_T_SSN, OSMO_SCCP_RI_GT, OSMO_SCCP_RI_NONE, OSMO_SCCP_RI_SSN_IP, OSMO_SCCP_RI_SSN_PC, osmo_ss7_pointcode_print(), osmo_sccp_addr::pc, osmo_sccp_addr::presence, osmo_sccp_addr::ri, osmo_ss7_instance::sccp_address_book, osmo_sccp_addr::ssn, and osmo_sccp_gt::tt.

Referenced by write_one_cs7().

## Variable Documentation

## as_node

struct cmd_node as_node

static

Initial value:
= {
L_CS7_AS_NODE,
"%s(config-cs7-as)# ",
1,
}

Referenced by vty_init_shared().

## asp_node

struct cmd_node asp_node

static

Initial value:
= {
L_CS7_ASP_NODE,
"%s(config-cs7-asp)# ",
1,
}

Referenced by vty_init_shared().

## cs7_node

struct cmd_node cs7_node

static

Initial value:
= {
L_CS7_NODE,
"%s(config-cs7)# ",
1,
}

Referenced by vty_init_shared().

## cs7_role

enum cs7_role_t cs7_role

static

Referenced by osmo_ss7_vty_init_asp(), and write_one_cs7().

## g_ctx

void* g_ctx

static

Referenced by DEFUN(), and vty_init_shared().

## mtp_si_vals

const struct value_string mtp_si_vals[]

Initial value:
= {
{ MTP_SI_SCCP, "sccp" },
{ MTP_SI_TUP, "tup" },
{ MTP_SI_ISUP, "isup" },
{ MTP_SI_DUP, "dup" },
{ MTP_SI_TESTING, "testing" },
{ MTP_SI_B_ISUP, "b-isup" },
{ MTP_SI_SAT_ISUP, "sat-isup" },
{ MTP_SI_AAL2_SIG, "aal2" },
{ MTP_SI_BICC, "bicc" },
{ MTP_SI_GCP, "h248" },
{ 0, NULL }
}
MTP_SI_GCP
@ MTP_SI_GCP
Definition: mtp.h:21
MTP_SI_BICC
@ MTP_SI_BICC
Definition: mtp.h:20
MTP_SI_ISUP
@ MTP_SI_ISUP
Definition: mtp.h:12
MTP_SI_B_ISUP
@ MTP_SI_B_ISUP
Definition: mtp.h:16
MTP_SI_SAT_ISUP
@ MTP_SI_SAT_ISUP
Definition: mtp.h:17
MTP_SI_TESTING
@ MTP_SI_TESTING
Definition: mtp.h:15
MTP_SI_DUP
@ MTP_SI_DUP
Definition: mtp.h:13
MTP_SI_TUP
@ MTP_SI_TUP
Definition: mtp.h:11
MTP_SI_AAL2_SIG
@ MTP_SI_AAL2_SIG
Definition: mtp.h:19
MTP_SI_SCCP
@ MTP_SI_SCCP
Definition: mtp.h:10

Referenced by _rout_key(), and write_one_as().

## rtable_node

struct cmd_node rtable_node

static

Initial value:
= {
L_CS7_RTABLE_NODE,
"%s(config-cs7-rt)# ",
1,
}

## sccpaddr_gt_node

struct cmd_node sccpaddr_gt_node

static

Initial value:
= {
L_CS7_SCCPADDR_GT_NODE,
"%s(config-cs7-sccpaddr-gt)# ",
1,
}

Referenced by vty_init_addr().

## sccpaddr_node

struct cmd_node sccpaddr_node

static

Initial value:
= {
L_CS7_SCCPADDR_NODE,
"%s(config-cs7-sccpaddr)# ",
1,
}

Referenced by vty_init_addr().

## ss7_network_indicator_vals

const struct value_string ss7_network_indicator_vals[]

static

Initial value:
= {
{ 0, "international" },
{ 1, "spare" },
{ 2, "national" },
{ 3, "reserved" },
{ 0, NULL }
}

Referenced by DEFUN(), and write_one_cs7().

## xua_node

struct cmd_node xua_node

static

Initial value:
= {
L_CS7_XUA_NODE,
"%s(config-cs7-listen)# ",
1,
}